package com.gyee.alarm.model.auto;

import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.util.Date;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 自定义报警配置
 * </p>
 *
 * @author shilin
 * @since 2023-08-09
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ProEconAlarmRule extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    private String id;

    /**
     * 自定义报警名称
     */
    private String name;

    /**
     * 报警描述
     */
    private String description;

    /**
     * 公式
     */
    private String expression;

    /**
     * 标签
     */
    private String tag;

    /**
     * 报警级别
     */
    private Integer rank;

    /**
     * 机型
     */
    private String modelId;

    /**
     * 报警类别
     */
    private String category;

    /**
     * 范围
     */
    private String range;

    /**
     * 场站ID
     */
    private String stationId;

    /**
     * 项目ID
     */
    private String projectId;

    /**
     * 线路ID
     */
    private String lineId;

    /**
     * 设备ID
     */
    private String deviceId;

    /**
     * 电气ID
     */
    private String electricalId;

    /**
     * 关联部件
     */
    private String relatedParts;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 是否启用
     */
    private Boolean enable;
    /**
     * 统一识别码(如果通过uniformCode配置，则设备类型，场站，机型不能为空)
     */
    private String uniformCode;


}
