package com.gyee.alarm.task.thread;

import com.gyee.alarm.init.CacheContext;
import com.gyee.alarm.model.auto.ProBasicPowerstationPoint;
import com.gyee.alarm.util.realtimesource.IEdosUtil;
import com.gyee.common.model.PointData;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Callable;
import java.util.concurrent.atomic.AtomicInteger;

public class ReadWsDataThreadPoolPool implements Callable<Integer>, Serializable {

	private Logger logger = LoggerFactory.getLogger(this.getClass());

	private static final long serialVersionUID = 0;

	// 保存任务所需要的数据


	private IEdosUtil edosUtil;

	private Integer readRows;

	private List<ProBasicPowerstationPoint> pointList;
	private StringBuilder str;

	private Integer interval;


	public ReadWsDataThreadPoolPool( IEdosUtil edosUtil, Integer readRows, List<ProBasicPowerstationPoint> pointList,
                                    Integer interval, StringBuilder str
	) {


		this.edosUtil = edosUtil;
		this.readRows = readRows;
		this.pointList = pointList;
		this.interval = interval;
		this.str = str;

	}

	public synchronized Integer call() throws Exception {

		Integer result = 1;

		try {

//			while (runStarted)
//			{
				List<String>  ls=new ArrayList<>();
				List<PointData> values=new ArrayList<>();

				AtomicInteger times = new AtomicInteger(0);
				for(ProBasicPowerstationPoint vo:pointList)
				{
					ls.add(vo.getNemCode());
					times.getAndAdd(1);
					if(times.get()==readRows)
					{
						List<PointData> templs=edosUtil.getRealData(ls);
						values.addAll(templs);
						ls=new ArrayList<>();
						times.set(0);
					}
				}
				if(!ls.isEmpty())
				{
					List<PointData> templs=edosUtil.getRealData(ls);
					values.addAll(templs);
				}

				if(values.size() == pointList.size())
				{

					for(int i=0;i<pointList.size();i++)
					{
						ProBasicPowerstationPoint point=pointList.get(i);
						PointData value=values.get(i);
						if(CacheContext.wsDataValueMap.containsKey(point.getWindpowerstationId()))
						{
							Map<String, PointData> map=CacheContext.wsDataValueMap.get(point.getWindpowerstationId());
							map.put(point.getUniformCode(),value);
						}else
						{
							Map<String, PointData> map=new HashMap<>();

							map.put(point.getUniformCode(),value);
							CacheContext.wsDataValueMap.put(point.getWindpowerstationId(),map);
						}
					}

				}

//				try {
//					Thread.sleep(interval * 1000);
//				} catch (InterruptedException e) {
//					throw new RuntimeException(e);
//				}
//			}

		} catch (Exception e) {

			e.printStackTrace();

			return 0;
		}


		return result;

	}



}