package com.gyee.alarm.model.auto;

import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 预警报告报警
 * </p>
 *
 * @author shilin
 * @since 2023-09-05
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ProEconEarlyReportAlarm extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID",type = IdType.INPUT)
    private String id;

    /**
     * 规则编号
     */
    private String ruleId;

    /**
     * 报警类型 custom为自定义报警，widnturbine为风机原始报警
     */
    private String alarmType;

    /**
     * 规则名称
     */
    private String ruleName;

    /**
     * 规则描述
     */
    private String ruleDescription;

    /**
     * 报警级别
     */
    private String rank;

    /**
     * 报警数量
     */
    private Long count;

    /**
     * 报警持续时长
     */
    private Double keepTime;

    /**
     * 预警风机报告表主键
     */
    private String reportWindturbineId;


}
