package com.gyee.alarm.controller;


import com.gyee.alarm.model.auto.ProEconEarlyWarnScore;
import com.gyee.alarm.service.EarlyWarnScoreService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 预警得分 前端控制器
 * </p>
 *
 * @author shilin
 * @since 2023-09-05
 */
@RestController
@RequestMapping("//earlywarnscore")
public class ProEconEarlyWarnScoreController {


    @Autowired
    private EarlyWarnScoreService earlyWarnScoreService;

    @GetMapping(value = "/list")
    @ApiOperation(value = "预警分数查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "windturbineid", value = "设备编号", required = true, dataType = "String", paramType = "query")
    })
    public List<ProEconEarlyWarnScore> getListEarlyWarnScore(String windturbineid) {
        List<ProEconEarlyWarnScore> lst = earlyWarnScoreService.getListEarlyWarnScore(windturbineid);
        return lst;
    }
}
